package com.hfkj.service;

import com.alibaba.fastjson.JSONObject;
import com.hfkj.entity.BsMer;
import com.hfkj.entity.BsMerIndustry;
import com.hfkj.entity.BsMerRegion;
import com.hfkj.entity.BsMerSettleAcct;
import com.hfkj.model.MerAccountModel;
import com.hfkj.model.MerBasisModel;
import com.hfkj.model.StoreModel;
import com.hfkj.sysenum.MerStatusEnum;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 商户
 * @author hurui
 */
public interface BsMerService {

    /**
     * 编辑商户
     * @param mer
     */
    void editMer(BsMer mer);

    /**
     * 配置商户账户
     * @param merAccount 账户参数
     * @return 返回商户的id
     */
    Long configMerAccount(MerAccountModel merAccount);

    /**
     * 配置商户基本信息
     * @param mer
     * @param merIndustry
     * @param merRegion
     */
    void configMerBasis(BsMer mer, BsMerIndustry merIndustry, BsMerRegion merRegion) throws IOException;

    /**
     * 配置商户结算信息
     * @param merSettleAcct
     */
    void configMerSettlement(BsMerSettleAcct merSettleAcct);

    /**
     * 配置商户门店
     * @param storeModel
     */
    void configMerStore(StoreModel storeModel) throws Exception;

    /**
     * 根据id 查询商户
     * @param merId
     * @return
     */
    BsMer getMer(Long merId);

    /**
     * 查询商户详情
     * @param merNo
     * @return
     */
    BsMer getMer(String merNo);

    /**
     * 复议提交
     * @param merId
     * @return
     */
    void reconsider(Long merId) throws Exception;

    /**
     * 查询商户列表
     * @param param
     * @return
     */
    List<BsMer> getMerList(Map<String, Object> param);

    /**
     * 根据id 查询商户详情
     * @param merId
     * @return
     */
    MerBasisModel getMerDetail(Long merId);

    /**
     * 拉卡拉商户进件回调
     * @param merId
     * @param merStatus
     * @param data
     */
    void laKaLaMerContractNotify(Long merId, MerStatusEnum merStatus, JSONObject data);

    /**
     * 统计商户数量
     * @param param
     * @return
     */
    long countMerSum(Map<String, Object> param);

}
